%donald
#code for the LHS, which is the actual diagramatic representation of the student post room.
viewport POSTROOMWINDOW
int postRoomWindowWidth
int postRoomWindowHeight
int postRoomBottomLeftX
int postRoomBottomLeftY
int entranceRightX
int entranceLeftX
int doorLeftX
int doorLeftY
int doorRightX
int doorRightY
point entranceRight
point entranceLeft
point entranceHeight
point entranceWidth
int doorWidth
boolean doorOpen
int tableTopLeftX
int tableTopLeftY
int tableBottomRightX
int tableBottomRightY
int noOfMailBoxes
int mBoxHeight
int mBoxWidth
int empRadius
int emp1XPos
int emp1YPos
char emp1Holding
int emp2XPos
int emp2YPos
char emp2Holding
int stuXPos
int stuYPos
char stuName
char stuHolding

char box1Cap
char box2Cap
char box3Cap
char box4Cap
char box5Cap
char box6Cap
char box7Cap
char box8Cap
char tableCap

doorOpen = pRoomIsOpen!
postRoomWindowWidth = pRoomWindowWidth!
postRoomWindowHeight = pRoomWindowHeight!
postRoomBottomLeftX = pRoomBottomLeftX!
postRoomBottomLeftY = pRoomBottomLeftY!
entranceRightX = entRightX!
entranceLeftX = entLeftX!
doorLeftX = drLeftX!
doorLeftY = drLeftY!
doorRightX = drRightX!
doorRightY = drRightY!
entranceRight = {entranceRightX,postRoomBottomLeftY}
entranceLeft = {entranceLeftX,postRoomBottomLeftY}
entranceHeight = {0, entHeight!}
entranceWidth = entranceRight-entranceLeft
doorWidth = drWidth!
tableTopLeftX = tableTLX!
tableTopLeftY = tableTLY!
tableBottomRightX = tableBRX!
tableBottomRightY = tableBRY!
noOfMailBoxes = numberOfMailBoxes!
mBoxHeight = mailBoxHeight!
mBoxWidth = mailBoxWidth!
empRadius = employeeRadius!
emp1XPos = employee1XPos!
emp1YPos = employee1YPos!
emp1Holding = employee1Holding!
emp2XPos = employee2XPos!
emp2YPos = employee2YPos!
emp2Holding = employee2Holding!
stuXPos = studentXPos!
stuYPos = studentYPos!
stuName = studentName!
stuHolding = studentHolding!

box1Cap = box1Capacity!
box2Cap = box2Capacity!
box3Cap = box3Capacity!
box4Cap = box4Capacity!
box5Cap = box5Capacity!
box6Cap = box6Capacity!
box7Cap = box7Capacity!
box8Cap = box8Capacity!
tableCap = tableCapacity!

#define the walls and door of the postroom.
openshape postRoomWalls
within postRoomWalls{
	line l,t,r,br,entrancel, entrancet, entrancer, bl, door
	l = [{~/postRoomBottomLeftX,~/postRoomBottomLeftY}, {~/postRoomBottomLeftX,~/postRoomBottomLeftY+~/postRoomWindowHeight}]
	t = [{~/postRoomBottomLeftX,~/postRoomBottomLeftY+~/postRoomWindowHeight}, {~/postRoomBottomLeftX+~/postRoomWindowWidth,~/postRoomBottomLeftY+~/postRoomWindowHeight}]
	r = [{~/postRoomBottomLeftX+~/postRoomWindowWidth,~/postRoomBottomLeftY+~/postRoomWindowHeight}, {~/postRoomBottomLeftX+~/postRoomWindowWidth,~/postRoomBottomLeftY}]
	br = [{~/postRoomBottomLeftX+~/postRoomWindowWidth,~/postRoomBottomLeftY}, ~/entranceRight]
	entrancer = [~/entranceRight, ~/entranceRight+~/entranceHeight]
	entrancet = [~/entranceRight+~/entranceHeight, ~/entranceLeft+~/entranceHeight]
	entrancel = [~/entranceLeft+~/entranceHeight, ~/entranceLeft]
	bl = [~/entranceLeft, {~/postRoomBottomLeftX,~/postRoomBottomLeftY}]
	door = [{~/doorLeftX, ~/doorLeftY}, {~/doorRightX, ~/doorRightY}]
}
#increase the width of the door line
?A_postRoomWalls_door = "linewidth=3";

openshape table
within table{
	rectangle table
	label name, capacity
	point labelPosition
	labelPosition = {(~/tableTopLeftX+~/tableBottomRightX) div 2, ~/tableBottomRightY+ (~/tableTopLeftY-~/tableBottomRightY) div 2}
	table = rectangle({~/tableTopLeftX, ~/tableTopLeftY}, {~/tableBottomRightX, ~/tableBottomRightY})
	name = label("Table", labelPosition)
	capacity = label(~/tableCap, {~/tableBottomRightX-20, ~/tableTopLeftY-20})
}

openshape mailBoxes
within mailBoxes{
	line line1, split1, split2, split3, split4, split5, split6, split7
	label box1,box2,box3,box4,box5,box6, box7, box8
	label l_box1cap,l_box2cap,l_box3cap,l_box4cap,l_box5cap,l_box6cap, l_box7cap, l_box8cap
	
	int midPointY
	int midPointX1
	midPointY = (~/postRoomBottomLeftY+~/postRoomWindowHeight) - (~/mBoxHeight) div 2
	midPointX1 = ~/postRoomBottomLeftX+((1*~/mBoxWidth) div 2)
	line1 = [{~/postRoomBottomLeftX,~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight},{~/tableTopLeftX,~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight}]
	split1 = [{~/postRoomBottomLeftX+(1*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight},{~/postRoomBottomLeftX+(1*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight}]
	split2 = [{~/postRoomBottomLeftX+(2*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight},{~/postRoomBottomLeftX+(2*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight}]
	split3 = [{~/postRoomBottomLeftX+(3*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight},{~/postRoomBottomLeftX+(3*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight}]
	split4 = [{~/postRoomBottomLeftX+(4*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight},{~/postRoomBottomLeftX+(4*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight}]
	split5 = [{~/postRoomBottomLeftX+(5*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight},{~/postRoomBottomLeftX+(5*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight}]
	split6 = [{~/postRoomBottomLeftX+(6*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight},{~/postRoomBottomLeftX+(6*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight}]
	split7 = [{~/postRoomBottomLeftX+(7*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight},{~/postRoomBottomLeftX+(7*~/mBoxWidth),~/postRoomBottomLeftY+~/postRoomWindowHeight-~/mBoxHeight}]
	
	box1 = label("AV", {1*midPointX1,midPointY})
	box2 = label("Hurst", {midPointX1 + 1*~/mBoxWidth,midPointY})
	box3 = label("JM", {midPointX1 + 2*~/mBoxWidth,midPointY})
	box4 = label("Redfern", {midPointX1 + 3*~/mBoxWidth,midPointY})
	box5 = label("Rootes", {midPointX1 + 4*~/mBoxWidth,midPointY})
	box6 = label("Tocil", {midPointX1 + 5*~/mBoxWidth,midPointY})
	box7 = label("WhiteF", {midPointX1 + 6*~/mBoxWidth,midPointY})	
	box8 = label("Other", {midPointX1 + 7*~/mBoxWidth,midPointY})	
	
	l_box1cap = label(~/box1Cap, {1*midPointX1+~/mBoxWidth div 3,midPointY+~/mBoxHeight div 3})
	l_box2cap = label(~/box2Cap, {midPointX1+~/mBoxWidth div 3 + 1*~/mBoxWidth,midPointY+~/mBoxHeight div 3})
	l_box3cap = label(~/box3Cap, {midPointX1+~/mBoxWidth div 3 + 2*~/mBoxWidth,midPointY+~/mBoxHeight div 3})
	l_box4cap = label(~/box4Cap, {midPointX1+~/mBoxWidth div 3 + 3*~/mBoxWidth,midPointY+~/mBoxHeight div 3})
	l_box5cap = label(~/box5Cap, {midPointX1+~/mBoxWidth div 3 + 4*~/mBoxWidth,midPointY+~/mBoxHeight div 3})
	l_box6cap = label(~/box6Cap, {midPointX1+~/mBoxWidth div 3 + 5*~/mBoxWidth,midPointY+~/mBoxHeight div 3})
	l_box7cap = label(~/box7Cap, {midPointX1+~/mBoxWidth div 3 + 6*~/mBoxWidth,midPointY+~/mBoxHeight div 3})	
	l_box8cap = label(~/box8Cap, {midPointX1+~/mBoxWidth div 3 + 7*~/mBoxWidth,midPointY+~/mBoxHeight div 3})
}

openshape employee1
within employee1{
	circle c1
	c1 = circle({~/emp1XPos,~/emp1YPos}, ~/empRadius)
	label holding
	holding = label(~/emp1Holding, {~/emp1XPos,~/emp1YPos})
}

openshape employee2
within employee2{
	circle c1
	c1 = circle({~/emp2XPos,~/emp2YPos}, ~/empRadius)
	label holding
	holding = label(~/emp2Holding, {~/emp2XPos,~/emp2YPos})
}

?A_employee1_c1 = "fill=solid,color=blue";
?A_employee2_c1 = "fill=solid,color=blue";

openshape student
within student{
	circle c1
	label name
	c1 = circle({~/stuXPos,~/stuYPos}, ~/empRadius)
	name = label(~/stuName, {~/stuXPos,~/stuYPos-~/empRadius*4})
	label holding
	holding = label(~/stuHolding, {~/stuXPos,~/stuYPos})
}
?A_student_c1 = "fill=solid,color=green";