%eden
include("postRoomDependencies.e");
%eden
include("allThePostRoomWindows.e");

%eden
proc openCloseDoor
{
	if(pRoomIsOpen==1)
	{
		pRoomIsOpen = 0;
	}
	else
	{
		pRoomIsOpen = 1;		
	}
};

proc openCloseButton_trigger : openCloseButton_mouse_1
{
	if(openCloseButton_mouse_1[2]==5)
	{
		openCloseDoor();	
	};
};

proc goToMailBox
{
	employeeNumber = $1;
	mailBoxNumber = $2;

	##calculate location of relevant mailbox
	mbXLoc = pRoomBottomLeftX+(mailBoxWidth/2) + (mailBoxNumber-1)*mailBoxWidth;
	mbYLoc = pRoomBottomLeftY + pRoomWindowHeight - mailBoxHeight - employeeRadius;
	
	##store the old x and y locations
	execute("oldXLoc = employee"//str(employeeNumber)//"XPos;");
	execute("oldYLoc = employee"//str(employeeNumber)//"YPos;");
	
	##get the new x and y locations
	execute("" // "employee"//str(employeeNumber)//"XPos="//str(mbXLoc)//";");
	execute("" // "employee"//str(employeeNumber)//"YPos="//str(mbYLoc)//";");
	
	##calculate the x and y velocities from old and new locations
	execute("(employee"//str(employeeNumber)//"XVelocity = employee"//str(employeeNumber)//"XPos - oldXLoc);");
	execute("(employee"//str(employeeNumber)//"YVelocity = employee"//str(employeeNumber)//"YPos - oldYLoc);");
	
	##scale down for animation purposes
	execute("employee"//str(employeeNumber)//"XVelocity = employee"//str(employeeNumber)//"XVelocity/movementSpeed;");
	execute("employee"//str(employeeNumber)//"YVelocity = employee"//str(employeeNumber)//"YVelocity/movementSpeed;");
	
	##set x and y positions to old values so they can be animated
	execute("" // "employee"//str(employeeNumber)//"XPos=oldXLoc;");
	execute("" // "employee"//str(employeeNumber)//"YPos=oldYLoc;");
	
	##start employee movement countdown
	execute("employee"//str(employeeNumber)//"MovementCountdown = movementSpeed;");
	
};

proc goToCounter
{
	employeeNumber = $1;
	
	##store the old x and y locations
	execute("oldXLoc = employee"//str(employeeNumber)//"XPos;");
	execute("oldYLoc = employee"//str(employeeNumber)//"YPos;");
	
	##get the new x and y locations
	execute("employee"//str(employeeNumber)//"XPos = (entRightX+entLeftX)/2;");
	execute("employee"//str(employeeNumber)//"YPos = pRoomBottomLeftY+entHeight+employeeRadius;");
	
	##calculate the x and y velocities from old and new locations
	execute("(employee"//str(employeeNumber)//"XVelocity = employee"//str(employeeNumber)//"XPos - oldXLoc);");
	execute("(employee"//str(employeeNumber)//"YVelocity = employee"//str(employeeNumber)//"YPos - oldYLoc);");
	
	##scale down for animation purposes
	execute("employee"//str(employeeNumber)//"XVelocity = employee"//str(employeeNumber)//"XVelocity/movementSpeed;");
	execute("employee"//str(employeeNumber)//"YVelocity = employee"//str(employeeNumber)//"YVelocity/movementSpeed;");
	
	##set x and y positions to old values so they can be animated
	execute("" // "employee"//str(employeeNumber)//"XPos=oldXLoc;");
	execute("" // "employee"//str(employeeNumber)//"YPos=oldYLoc;");
	
	##start employee movement countdown
	execute("employee"//str(employeeNumber)//"MovementCountdown = movementSpeed;");
};

proc goToTable
{
	employeeNumber = $1;
	
	##store the old x and y locations
	execute("oldXLoc = employee"//str(employeeNumber)//"XPos;");
	execute("oldYLoc = employee"//str(employeeNumber)//"YPos;");
	
	##get the new x and y locations
	execute("employee"//str(employeeNumber)//"XPos = (tableTLX + tableBRX)/2;");
	execute("employee"//str(employeeNumber)//"YPos = tableBRY - employeeRadius;");

	##calculate the x and y velocities from old and new locations
	execute("(employee"//str(employeeNumber)//"XVelocity = employee"//str(employeeNumber)//"XPos - oldXLoc);");
	execute("(employee"//str(employeeNumber)//"YVelocity = employee"//str(employeeNumber)//"YPos - oldYLoc);");
	
	##scale down for animation purposes
	execute("employee"//str(employeeNumber)//"XVelocity = employee"//str(employeeNumber)//"XVelocity/movementSpeed;");
	execute("employee"//str(employeeNumber)//"YVelocity = employee"//str(employeeNumber)//"YVelocity/movementSpeed;");
	
	##set x and y positions to old values so they can be animated
	execute("" // "employee"//str(employeeNumber)//"XPos=oldXLoc;");
	execute("" // "employee"//str(employeeNumber)//"YPos=oldYLoc;");
	
	##start employee movement countdown
	execute("employee"//str(employeeNumber)//"MovementCountdown = movementSpeed;");
};

proc personArrive
{
	personToMove = $1;
	
	##store the old x and y locations
	execute("oldXLoc = "//personToMove//"XPos;");
	execute("oldYLoc = "//personToMove//"YPos;");
	
	##get the new x and y locations
	execute(personToMove//"XPos = (entRightX+entLeftX)/2;");
	execute(personToMove//"YPos = pRoomBottomLeftY+entHeight-employeeRadius;");

	##calculate the x and y velocities from old and new locations
	execute("("//personToMove//"XVelocity = "//personToMove//"XPos - oldXLoc);");
	execute("("//personToMove//"YVelocity = "//personToMove//"YPos - oldYLoc);");
	
	##scale down for animation purposes
	execute(personToMove//"XVelocity = "//personToMove//"XVelocity/movementSpeed;");
	execute(personToMove//"YVelocity = "//personToMove//"YVelocity/movementSpeed;");
	
	##set x and y positions to old values so they can be animated
	execute(personToMove//"XPos=oldXLoc;");
	execute(personToMove//"YPos=oldYLoc;");
	
	##start employee movement countdown
	execute(personToMove//"MovementCountdown = movementSpeed;");
	
	
};

proc personLeave
{
	personToMove = $1;
	
	##store the old x and y locations
	execute("oldXLoc = "//personToMove//"XPos;");
	execute("oldYLoc = "//personToMove//"YPos;");
	
	##get the new x and y locations
	execute(personToMove//"XPos = (entRightX+entLeftX)/2;");
	execute(personToMove//"YPos = -2*employeeRadius;");

	##calculate the x and y velocities from old and new locations
	execute("("//personToMove//"XVelocity = "//personToMove//"XPos - oldXLoc);");
	execute("("//personToMove//"YVelocity = "//personToMove//"YPos - oldYLoc);");
	
	##scale down for animation purposes
	execute(personToMove//"XVelocity = "//personToMove//"XVelocity/movementSpeed;");
	execute(personToMove//"YVelocity = "//personToMove//"YVelocity/movementSpeed;");
	
	##set x and y positions to old values so they can be animated
	execute(personToMove//"XPos=oldXLoc;");
	execute(personToMove//"YPos=oldYLoc;");
	
	##start employee movement countdown
	execute(personToMove//"MovementCountdown = movementSpeed;");
};

%eden
##increments time by one and makes sure its in correct format
proc moveTimeForward
{
	##included day, month, year, hour, day rollover
	if(systemStartMinute!=59)
	{
		systemStartMinute++;
	}
	else ##next hour
	{
		systemStartMinute = 0;
		if(systemStartHour!=23)
		{
			systemStartHour++;
		}
		else ##next hour
		{
			systemStartHour = 0;
			if((systemStartMonth == 9) || (systemStartMonth == 4) || (systemStartMonth == 6) || (systemStartMonth == 11))
			{
				if(systemStartDay!=30)
				{
					systemStartDay++;
				}
				else
				{
					systemStartDay = 1;
					if(systemStartMonth!=12)
					{
						systemStartMonth++;
					}
					else
					{
						systemStartMonth = 1;
						systemStartYear++;
					}
				}
			}
			else if (systemStartMonth == 2)
			{
				if(systemStartDay!=28)
				{
					systemStartDay++;
				}
				else
				{
					systemStartDay = 1;
					if(systemStartMonth!=12)
					{
						systemStartMonth++;
					}
					else
					{
						systemStartMonth = 1;
						systemStartYear++;
					}
				}
			}
			else
			{
				if(systemStartDay!=31)
				{
					systemStartDay++;
				}
				else
				{
					systemStartDay = 1;
					if(systemStartMonth!=12)
					{
						systemStartMonth++;
					}
					else
					{
						systemStartMonth = 1;
						systemStartYear++;
					}
				}
			}
			
		}
	}
	
	##opening times of post room.
	if((systemStartHour==8) && (systemStartMinute==30))
	{
		##start employees arrive process
		employee1ArriveState = 1;
		employee2ArriveState = 1;
		employee1MoveTime = clock+1; ##+1 as everything will get done on the next clock
		employee2MoveTime = clock+1; ##+1 as everything will get done on the next clock
		
		if(autoOrManual == "Automatic")
		{
			rndNumber = rnd(numberOfSpreadsheetElements);
			loadMailLedgerTextbox_setText(str(rndNumber));
			loadMailLedger();
		};
		

	}
	
	##start of lunch break 
	if((systemStartHour==12) && (systemStartMinute==0))
	{
		##start employees leave process
		employee1LeaveState = 1;
		employee2LeaveState = 1;
		employee1MoveTime = clock+1; ##+1 as everything will get done on the next clock
		employee2MoveTime = clock+1; ##+1 as everything will get done on the next clock
		outToLunch = 1;
	}
	
	##end of lunch break 
	if((systemStartHour==13) && (systemStartMinute==0))
	{
		##start employees leave process
		employee1ArriveState = 1;
		employee2ArriveState = 1;
		employee1MoveTime = clock+1; ##+1 as everything will get done on the next clock
		employee2MoveTime = clock+1; ##+1 as everything will get done on the next clock
		outToLunch = 0;	
	}
	
	##closing time of post room
	if((systemStartHour==17) && (systemStartMinute==0))
	{
		##start employees leave process
		employee1LeaveState = 1;
		employee2LeaveState = 1;
		employee1MoveTime = clock+1; ##+1 as everything will get done on the next clock
		employee2MoveTime = clock+1; ##+1 as everything will get done on the next clock
		
		
	}
	
};

proc employeeLeaveProcess
{
	##employee leave process
	
	##set the status label to say employees leaving. 
	if((employee1LeaveState == 1) || (employee2LeaveState == 1))
	{
		##SLOW ACTUAL TIME SO PROCESSING TIMES ARE REALISTIC
		setedenclock(&timeclock, 10000/10);
		status = "Employees Leaving...";
	};
	
	if((employee1LeaveState == 1) && (transactionState == 0) )
	{
		employee1MoveTime = clock+1; ##+1 as everything will get done on the next clock
		employee1LeaveState = 2;		
	}
	else if(employee1LeaveState == 2 )
	{
		if(employee1MoveTime == clock)
		{
			goToCounter(1);
		};
		if(employee1MoveTime+movementSpeed == clock)
		{
			employee1LeaveState = 3;
			emp1Status = "Leaving...";
		};
	}
	else if(employee1LeaveState==3)
	{
		if(employee1MoveTime+movementSpeed+1 == clock)
		{
			personLeave("employee1");
			##if the door has been closed open it.
			if(pRoomIsOpen == 0)
			{
				openCloseDoor();
			};
		};
		if(employee1MoveTime+movementSpeed+1+movementSpeed == clock)
		{
			employee1LeaveState = 4;
		};
		
	}
	else
	{}
	
	if((employee2LeaveState == 1) && (sortingState == 0) )
	{
		employee2MoveTime = clock+1; ##+1 as everything will get done on the next clock
		employee2LeaveState = 2;
		emp2Status = "Leaving...";
	}
	else if(employee2LeaveState == 2)
	{
		if(employee2MoveTime+2 == clock)
		{
			goToCounter(2);
		};
		if(employee2MoveTime+2+movementSpeed == clock)
		{
			employee2LeaveState = 3;
		};
	}
	else if(employee2LeaveState==3)
	{
		if(employee2MoveTime+2+movementSpeed+1 == clock)
		{
			personLeave("employee2");
			##if the door has been closed open it.
			if(pRoomIsOpen == 0)
			{
				openCloseDoor();
			};
		};
		if(employee2MoveTime+2+movementSpeed+1+movementSpeed == clock)
		{
			employee2LeaveState = 4;
		};
		
	}
	else
	{}
	
	
	if( ( (employee1LeaveState == 4) && (employee2LeaveState == 4) ) || ( (employee1LeaveState == 5) && (employee2LeaveState == 4) ) || ( (employee1LeaveState == 4) && (employee2LeaveState == 5) ) )
	{
		
	};
	
	if(employee1LeaveState == 4)
	{
		##reset leave state
		employee1LeaveState = 5;
		emp1Status = "Out...";
	}
	
	if(employee2LeaveState == 4)
	{
		##reset leave state
		employee2LeaveState = 5;
		emp2Status = "Out...";
	}
	
	if((employee1LeaveState == 5) && (employee2LeaveState == 5))
	{
		if(outToLunch == 1)
		{
			status = "Out To Lunch...";
		}
		else
		{
			status = "Idle...";		
		}
		
		##close the door when both out
		if(pRoomIsOpen==1) 
		{
			openCloseDoor();
		}
		
		employee1LeaveState = 0;
		employee2LeaveState = 0;
		
		##RESET ACTUAL TIME SPEED
		setedenclock(&timeclock, 10000/actualTimeSpeed);
	};
};

proc employeeArriveProcess
{
	##employee arrive process
	
	##set the status label to say employees arriving. 
	if((employee1ArriveState == 1) || (employee2ArriveState == 1))
	{
		##SLOW ACTUAL TIME SO PROCESSING TIMES ARE REALISTIC
		setedenclock(&timeclock, 10000/10);
		status = "Employees Arriving...";
	};
	
	##open the door in the morning
	if((pRoomIsOpen==0) && (employee1ArriveState == 1) && (employee2ArriveState == 1))
	{
		openCloseDoor();		
		
		status = "Employees Arriving...";
	};
	
	if(employee1ArriveState == 1)
	{
		if(employee1MoveTime == clock)
		{
			personArrive("employee1");
			emp1Status = "Arriving...";
		};
		if(employee1MoveTime+movementSpeed == clock)
		{
			employee1ArriveState = 2;
		};
	}
	else if(employee1ArriveState==2)
	{
		if(employee1MoveTime+movementSpeed+1 == clock)
		{
			goToCounter(1);
		};
		if(employee1MoveTime+movementSpeed+1+movementSpeed == clock)
		{
			employee1ArriveState = 3;
		};
		
	}
	else
	{}
	
	if(employee2ArriveState == 1)
	{
		if(employee2MoveTime+2 == clock)
		{
			personArrive("employee2");
			emp2Status = "Arriving...";
		};
		if(employee2MoveTime+2+movementSpeed == clock)
		{
			employee2ArriveState = 2;
		};
	}
	else if(employee2ArriveState==2)
	{
		if(employee2MoveTime+2+movementSpeed+1 == clock)
		{
			goToTable(2);
		};
		if(employee2MoveTime+2+movementSpeed+1+movementSpeed == clock)
		{
			employee2ArriveState = 3;
		};
		
	}
	else
	{}
	
	if((employee1ArriveState == 3) || (employee2ArriveState == 3))
	{
		##reset arrive states
		employee1ArriveState = 0;
		employee2ArriveState = 0;
		
		emp1Status = "Idle...";
		emp2Status = "Idle...";
		
		status = "Idle...";	
		
		##RESET ACTUAL TIME SPEED
		setedenclock(&timeclock, 10000/actualTimeSpeed);	
	};
};

proc dealWithTransaction
{
	if(transactionState == 1 && transactionStartTime == clock)
	{
		currentStudent = collectingStudentList[1];
		execute( "studentName is allTheMail[" // str(currentStudent) // "][1];" );
		##if post room is open 
		if(pRoomIsOpen == 1)
		{
			##SLOW ACTUAL TIME SO PROCESSING TIMES ARE REALISTIC
			setedenclock(&timeclock, 10000/2);
			
			##enter the student
			personArrive("student");
			
			##update the status
			status = "Student Arriving...";
		}
		else ##post room is closed
		{
			transactionState = -1;
			##update the status
			status = "Student Arriving...";
		}
		
	};
	
	##if a student cant get in because the door is closed
	if(transactionState == -1 && transactionStartTime+2 == clock)
	{
		##update the status
		status = "Student leaves...";
	};
	
	##if a student cant get in because the door is closed and its end of the process.
	if(transactionState == -1 && transactionStartTime+2+2 == clock)
	{
		transactionState = 0;
		status = "Idle...";	
		emp1Status = "Idle...";
		
		##if its on the correct page. 
		startValOfCurrentPage = (numberOfSpreadsheetElements*(currentPageNumber-1))+1;
		endValOfCurrentPage = startValOfCurrentPage+numberOfSpreadsheetElements-1;
		
		if((startValOfCurrentPage<=currentStudent) && (endValOfCurrentPage>=currentStudent))
		{
			execute( "button" // str(currentStudent-startValOfCurrentPage+1) // "Colour = \"green\";" );
		};		
		
		execute( "allTheMail[" // str(currentStudent) // "][5] = \"green\";");
		delete collectingStudentList, 1;
	};
	
	##when the student has reached the counter
	if(transactionState == 1 && transactionStartTime+movementSpeed == clock)
	{
		transactionState = 2;
		status = "Dealing with student...";
		##move emp1 to the counter
		goToCounter(1);
		emp1Status = "Going to counter...";
		
		##reset the colours of the ticks.
		mailCardTicColour is backgroundColour;
		studentIDTicColour is backgroundColour;
		retrieveParcelTicColour is backgroundColour;
		getFormTicColour is backgroundColour;
		signTicColour is backgroundColour;
	};
	
	##when the employee has reached the counter
	if(transactionState == 2 && transactionStartTime+(2*movementSpeed) == clock)
	{
		emp1Status = "Requesting Mail Card...";
	};
	
	##after getting the mail card.
	if(transactionState == 2 && transactionStartTime+(2*movementSpeed)+1 == clock)
	{
		mailCardTicColour = "limegreen";
		emp1Status = "Requesting Student ID...";
	};
	
	##after getting the student card.
	if(transactionState == 2 && transactionStartTime+(2*movementSpeed)+1+2 == clock)
	{
		studentIDTicColour = "limegreen";
		emp1Status = "Retrieving Parcel...";
		
		execute(
		"currentAddress = allTheMail[" // str(currentStudent) // "][2];" 
		);
		
		##choose the mail box to go to.
		if(currentAddress[1] == 'A')
		{
			currentMailBox = 1;
			goToMailBox(1,1);
		}
		else if(currentAddress[1] == 'H')
		{
			currentMailBox = 2;
			goToMailBox(1,2);
		}
		else if(currentAddress[1] == 'J')
		{
			currentMailBox = 3;
			goToMailBox(1,3);
		}
		else if(currentAddress[1] == 'R' && currentAddress[2] == 'e')
		{
			currentMailBox = 4;
			goToMailBox(1,4);
		}
		else if(currentAddress[1] == 'R' && currentAddress[2] == 'o')
		{
			currentMailBox = 5;
			goToMailBox(1,5);
		}
		else if(currentAddress[1] == 'T')
		{
			currentMailBox = 6;
			goToMailBox(1,6);
		}
		else if(currentAddress[1] == 'W')
		{
			currentMailBox = 7;
			goToMailBox(1,7);
		}
		else
		{
			currentMailBox = 8;
			goToMailBox(1,8);
		}
	};
	
	##after getting to the mailbox.
	if(transactionState == 2 && transactionStartTime+(2*movementSpeed)+1+2+(1*movementSpeed)== clock)
	{
		goToCounter(1);
		employee1Holding = "P";
		##decrement capacity for the mail box taken from.
		execute( "box" // str(currentMailBox) // "Capacity--;" );
	};
	
	##after getting back from retrieving the parcel.
	if(transactionState == 2 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)== clock)
	{
		transactionState = 3;
		retrieveParcelTicColour = "limegreen";
		emp1Status = "Giving Parcel...";
	};
	
	##go get the form to sign 
	if(transactionState == 3 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)+2== clock)
	{
		employee1Holding = "";
		studentHolding = "P";
		transactionState = 3;
		emp1Status = "Retrieving Form...";
		goToTable(1);
	};
	
	##after got the form to sign 
	if(transactionState == 3 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)+2+(1*movementSpeed)== clock)
	{
		employee1Holding = "F";
		goToCounter(1);
	};
	
	##after got the form to sign 
	if(transactionState == 3 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)+2+(2*movementSpeed)== clock)
	{
		transactionState = 4;
		emp1Status = "Waiting for signature...";
		getFormTicColour = "limegreen";		
	};
	
	##after got signature, the student leaves and the date gets recorded.
	if(transactionState == 4 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)+2+(2*movementSpeed)+2== clock)
	{
		transactionState = 5;
		personLeave("student");
		
		##if the door has been closed open it.
		if(pRoomIsOpen == 0)
		{
			openCloseDoor();
		};
		
		emp1Status = "Recording pick up date...";
		status = "Student Leaving...";
		signTicColour = "limegreen";		
	};
	
	##after the student has left, reset the status to "idle...".
	if(transactionState == 5 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)+2+(2*movementSpeed)+2== clock)
	{
		status = "Idle...";	
		stuHolding = "";			
	};
	
	##after the student leaves, the date gets recorded, and the employee returns the form..
	if(transactionState == 5 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)+2+(2*movementSpeed)+2+2== clock)
	{
		##record current date and disable button
		currentDate = stringSystemStartDay //"-"//stringSystemStartMonth//"-"//stringSystemStartYear;
				
		##if its on the correct page. 
		startValOfCurrentPage = (numberOfSpreadsheetElements*(currentPageNumber-1))+1;
		endValOfCurrentPage = startValOfCurrentPage+numberOfSpreadsheetElements-1;
		writeln(startValOfCurrentPage);
		writeln(endValOfCurrentPage);
		if((startValOfCurrentPage<=currentStudent) && (endValOfCurrentPage>=currentStudent))
		{
			execute(
			"element4" // str(currentStudent-startValOfCurrentPage+1) // "_setText(currentDate);" //
			"button" // str(currentStudent-startValOfCurrentPage+1) // "Colour = \"black\";"
			);
		};
		
		execute(
		"allTheMail[" // str(currentStudent) // "][4] = currentDate;"//
		"allTheMail[" // str(currentStudent) // "][5] = \"black\";"
		);
		
		
		goToTable(1);
		
		emp1Status = "Returning Form...";
		
	};
	
	##go back from table
	if(transactionState == 5 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)+2+(2*movementSpeed)+2+2+(1*movementSpeed)== clock)
	{
		employee1Holding = "";
		goToCounter(1);
		emp1Status = "Going to counter...";			
	};
	
	##process over
	if(transactionState == 5 && transactionStartTime+(2*movementSpeed)+1+2+(2*movementSpeed)+2+(2*movementSpeed)+2+2+(2*movementSpeed)== clock)
	{
		##remove the parcel just collected from list
		delete collectingStudentList, 1;
		
		transactionState = 0;
		status = "Idle...";	
		emp1Status = "Idle...";		
		
		##RESET ACTUAL TIME SPEED
		setedenclock(&timeclock, 10000/actualTimeSpeed);
	};
	
	##this will check to see if any students are queue up. if they are then a transaction process is started
	##it is here as i dont want the process to start in the same clock cycle
	if((collectingStudentList# > 0) && (transactionState == 0)  && (employee1ArriveState == 0) && (employee1LeaveState==0))
	{
		transactionState = 1;
		transactionStartTime=clock+1;	
	};	
};

proc sortMail
{
	##if not sorting at all - dont sort if door is closed or emp2 is arriving or leaving.
	if((sortingState == 0) && (parcelsToSort#>0) && (pRoomIsOpen == 1)  && (employee2ArriveState == 0) && (employee2LeaveState == 0) )
	{
		sortingState = 1;
		
		sortingStartTime = clock;
		
		##SLOW ACTUAL TIME SO PROCESSING TIMES ARE REALISTIC
		setedenclock(&timeclock, 10000/1);
	};
	
	##if there is a parcel to sort. 
	if((sortingState == 1) && (sortingStartTime+movementSpeed == clock))
	{
		status = "Sorting mail...";
		emp2Status = "Writing to ledger...";
	};
	
	##with delay (process of sorting), add to ledger 
	if((sortingState == 1) && (sortingStartTime+movementSpeed + 2 == clock))
	{
		startValOfCurrentPage = (numberOfSpreadsheetElements*(currentPageNumber-1))+1;
		endValOfCurrentPage = startValOfCurrentPage+numberOfSpreadsheetElements-1;
		if((startValOfCurrentPage<=mailQuantity+1) && (endValOfCurrentPage>=mailQuantity+1))
		{
			execute( "element1" // str(mailQuantity+1-startValOfCurrentPage+1) // "_setText(" // "\"" // parcelsToSort[1][1] // "\");");
		};
		                                                                                                 
	};
	
	if((sortingState == 1) && (sortingStartTime+movementSpeed + 3 == clock))
	{
		startValOfCurrentPage = (numberOfSpreadsheetElements*(currentPageNumber-1))+1;
		endValOfCurrentPage = startValOfCurrentPage+numberOfSpreadsheetElements-1;
		if((startValOfCurrentPage<=mailQuantity+1) && (endValOfCurrentPage>=mailQuantity+1))
		{
			execute( "element2" // str(mailQuantity+1-startValOfCurrentPage+1) // "_setText(" // "\"" // parcelsToSort[1][2] // "\");");
		};
	};
	
	if((sortingState == 1) && (sortingStartTime+movementSpeed + 4 == clock))
	{
		startValOfCurrentPage = (numberOfSpreadsheetElements*(currentPageNumber-1))+1;
		endValOfCurrentPage = startValOfCurrentPage+numberOfSpreadsheetElements-1;
		if((startValOfCurrentPage<=mailQuantity+1) && (endValOfCurrentPage>=mailQuantity+1))
		{
			execute( "element3" // str(mailQuantity+1-startValOfCurrentPage+1) // "_setText(" // "\"" // parcelsToSort[1][3] // "\");");
		};
	};
	
	##and take over to required mailbox.
	if((sortingState == 1) && (sortingStartTime+movementSpeed + 5 == clock))
	{
		startValOfCurrentPage = (numberOfSpreadsheetElements*(currentPageNumber-1))+1;
		endValOfCurrentPage = startValOfCurrentPage+numberOfSpreadsheetElements-1;
		if((startValOfCurrentPage<=mailQuantity+1) && (endValOfCurrentPage>=mailQuantity+1))
		{
			execute( "element4" // str(mailQuantity+1-startValOfCurrentPage+1) // "_setText(" // "\"" // parcelsToSort[1][4] // "\");");
			
			##enable button -> set to green
			onColour = "green";
			execute("button"//str(mailQuantity+1-startValOfCurrentPage+1)//"Colour = onColour;");
		};	
			
		
		##add to list of all the mail
		allTheMail = allTheMail // [[parcelsToSort[1][1], parcelsToSort[1][2], parcelsToSort[1][3], parcelsToSort[1][4], "green"]];
		
		##dont need mailQuantity+1 as mailQuantity is dependant on allTheMail# and this is now 1 bigger
		if(mailQuantity%numberOfSpreadsheetElements == 0) ##need new page
		{
			totalPages++;
		};
				
		##choose the mail box to go to.
		if(parcelsToSort[1][2][1] == 'A')
		{
			goToMailBox(2,1);
		}
		else if(parcelsToSort[1][2][1] == 'H')
		{
			goToMailBox(2,2);
		}
		else if(parcelsToSort[1][2][1] == 'J')
		{
			goToMailBox(2,3);
		}
		else if(parcelsToSort[1][2][1] == 'R' && parcelsToSort[1][2][2] == 'e')
		{
			goToMailBox(2,4);
		}
		else if(parcelsToSort[1][2][1] == 'R' && parcelsToSort[1][2][2] == 'o')
		{
			goToMailBox(2,5);
		}
		else if(parcelsToSort[1][2][1] == 'T')
		{
			goToMailBox(2,6);
		}
		else if(parcelsToSort[1][2][1] == 'W')
		{
			goToMailBox(2,7);
		}
		else
		{
			goToMailBox(2,8);
		}
		
		emp2Status = "Transferring parcel...";
				
		##give emp2 a parcel and decrement count of parcels on table
		employee2Holding = "P";
		tableCapacity --;
				
		##reset sorting start time, so everything is relative to when state 2 started
		sortingStartTime = clock;
		sortingState = 2;
		
	};
	
	##when emp2 got to mail box.
	if((sortingState == 2) && (sortingStartTime + movementSpeed == clock))
	{
		##choose the mail box at.
		if(parcelsToSort[1][2][1] == 'A')
		{
			box1Capacity++;
		}
		else if(parcelsToSort[1][2][1] == 'H')
		{
			box2Capacity++;
		}
		else if(parcelsToSort[1][2][1] == 'J')
		{
			box3Capacity++;
		}
		else if(parcelsToSort[1][2][1] == 'R' && parcelsToSort[1][2][2] == 'e')
		{
			box4Capacity++;
		}
		else if(parcelsToSort[1][2][1] == 'R' && parcelsToSort[1][2][2] == 'o')
		{
			box5Capacity++;
		}
		else if(parcelsToSort[1][2][1] == 'T')
		{
			box6Capacity++;
		}
		else if(parcelsToSort[1][2][1] == 'W')
		{
			box7Capacity++;
		}
		else
		{
			box8Capacity++;
		}
		
		##emp2 no longer is holding anything.
		employee2Holding = "";
		
		##send emp2 back to table
		goToTable(2);
		emp2Status = "Going back to table...";
		
		##reset sorting start time, so everything is relative to when state 3 started
		sortingState = 3;
		sortingStartTime = clock;
	};
	
	##when got back and sorting is over
	if((sortingState == 3)  && (sortingStartTime + movementSpeed == clock))
	{
		status = "Idle...";
		emp2Status = "Idle...";
		sortingState = 0;
		
		##remove head from list
		delete parcelsToSort, 1;
		
		##RESET ACTUAL TIME SPEED
		setedenclock(&timeclock, 10000/actualTimeSpeed);
	};
};

##method that gets called whenever the page get changed.
proc flipPage : currentPageNumber
{
	resetLedgerElements();
	
	if(mailQuantity > 0)
	{
		insertToLedger();
	};
};

proc insertToLedger
{
	writeln("\n\n\n\n\n\n\n");
	##go through all the mail on the correct page
	j = 1;
	startVal = (numberOfSpreadsheetElements*(currentPageNumber-1))+1;
	endVal = (startVal+numberOfSpreadsheetElements>mailQuantity) ? mailQuantity : startVal+numberOfSpreadsheetElements-1;
	
	writeln(startVal);
	writeln(endVal);
	
	for (i=startVal; i<=endVal; i++)
	{
		currEl = allTheMail[i];
		writeln(currEl);
		
		execute( "element1"// str(i-startVal+1) // "_setText(currEl[1]);" );
		execute( "element2"// str(i-startVal+1) // "_setText(currEl[2]);" );
		execute( "element3"// str(i-startVal+1) // "_setText(currEl[3]);" );
		execute( "element4"// str(i-startVal+1) // "_setText(currEl[4]);" );
		execute( "button"// str(i-startVal+1) // "Colour = currEl[5];" );
	};
};

##this is the animation procedure
proc animate : clock 
{
	##if in auto mode randomly make student go to pick up.
	if(autoOrManual == "Automatic")
	{
		randomNumber = rnd(10);
		if((randomNumber == 1) && (mailQuantity > 0)) ##make student arrive
		{
			studentToCollectMail(rnd(mailQuantity-1)+1);			
		};
	};	

	employeeLeaveProcess();
	
	employeeArriveProcess();
	
	dealWithTransaction();	
	
	sortMail();
	
	##go through all the employees and move them by their velocities
	for(i=1; i<=numberOfEmployees; i++)
	{
		currEmpX = "employee"//str(i)//"XPos";
		currEmpY = "employee"//str(i)//"YPos";
		
		execute(
		"if (employee"//str(i)//"MovementCountdown > 0)" //
		"{" // 
			"employee"//str(i)//"XPos = employee"//str(i)//"XPos + employee"//str(i)//"XVelocity;"//
			"employee"//str(i)//"YPos = employee"//str(i)//"YPos + employee"//str(i)//"YVelocity;"//
			"employee"//str(i)//"MovementCountdown--;"//
		"};"
		);
	}
	
	currStuX = studentXPos;
	currStuY = studentYPos;
		
	execute(
	"if (student"//"MovementCountdown > 0)" //
	"{" // 
		"studentXPos = studentXPos + studentXVelocity;"//
		"studentYPos = studentYPos + studentYVelocity;"//
		"studentMovementCountdown--;"//
	"};"
	);
}

proc timeMovement : timeclock
{
	##move forward time by 1
	moveTimeForward();
};	
##set the textbox to be the clockspeed
clockSpeedTextbox_setText(str(actualTimeSpeed));


