%scout

string autoOrManual;
integer clockSpeed;

window systemButtonsFrame = 
{
	type: TEXT
	frame: ([{systemButtonsStartX,systemButtonsStartY},{systemButtonsStartX+systemButtonsWindowWidth,systemButtonsStartY+systemButtonsWindowHeight}])
	bgcolour: backgroundColour
	border: 1
};

window systemButtonsTitle = 
{
	type: TEXT
	string: "System Buttons"
	frame: ([{systemButtonsStartX+1,systemButtonsStartY+1},{systemButtonsStartX+systemButtonsWindowWidth-1,systemButtonsStartY+15}])
	font: "{arial 10 bold}"
	alignment: CENTRE
	bgcolour: backgroundColour
	
};

window autoManualButton = 
{
	type: TEXT
	string: autoOrManual
	frame: ([{systemButtonsStartX+10,systemButtonsStartY+15+(1*10)+(0*systemButtonsSectionSize)},{systemButtonsStartX+systemButtonsWindowWidth-10,systemButtonsStartY+15+(2*10)+(0*systemButtonsSectionSize)}])
	alignment: CENTRE
	border: 1
	sensitive: ON
	bgcolour: "grey"
};

window loadMailLedgerTextbox = 
{
	type: TEXTBOX
	frame: ([{systemButtonsStartX+10,systemButtonsStartY+15+(2*10)+(1*systemButtonsSectionSize)},{2,0.9}])
	bgcolour: "white"
	sensitive: ON
};

window loadMailLedgerButton = 
{
	type: TEXT
	string: "Load Mail Ledger"
	frame: ([{systemButtonsStartX+10+(4*1.c),systemButtonsStartY+15+(2*10)+(1*systemButtonsSectionSize)+1},{systemButtonsStartX+systemButtonsWindowWidth-10,systemButtonsStartY+15+(3*10)+(1*systemButtonsSectionSize)+1}])
	alignment: CENTRE
	border: 1
	sensitive: ON
	bgcolour: "grey"
};

window clockSpeedTextbox = 
{
	type: TEXTBOX
	frame: ([{systemButtonsStartX+10,systemButtonsStartY+15+(3*10)+(2*systemButtonsSectionSize)},{5,0.9}])
	bgcolour: "white"
	sensitive: ON
};

window clockSpeedButton = 
{
	type: TEXT
	string: "Set Clock Speed"
	frame: ([{systemButtonsStartX+10+(7*1.c),systemButtonsStartY+15+(3*10)+(2*systemButtonsSectionSize)+1},{systemButtonsStartX+systemButtonsWindowWidth-10,systemButtonsStartY+15+(4*10)+(2*systemButtonsSectionSize)+1}])
	alignment: CENTRE
	border: 1
	sensitive: ON
	bgcolour: "grey"
};

window resetButton = 
{
	type: TEXT
	string: "Reset"
	frame: ([{systemButtonsStartX+10,systemButtonsStartY+15+(4*10)+(3*systemButtonsSectionSize)},{systemButtonsStartX+systemButtonsWindowWidth-10,systemButtonsStartY+15+(5*10)+(3*systemButtonsSectionSize)}])
	alignment: CENTRE
	border: 1
	sensitive: ON
	bgcolour: "grey"
};

%eden

proc autoManualButton_trigger : autoManualButton_mouse_1
{
	if(autoManualButton_mouse_1[2] == 5)
	{
		if(autoOrManual=="Automatic")
		{
			autoOrManual = "Manual";
		}
		else
		{
			autoOrManual = "Automatic";
		}
	};
	
};

proc loadMailLedgerButton_trigger : loadMailLedgerButton_mouse_1
{
	if(loadMailLedgerButton_mouse_1[2] == 5)
	{
		loadMailLedger();
	};
};

proc loadMailLedger
{
	randomise();
		
	loadLedgerSize = int(loadMailLedgerTextbox_getText());
		
	firstName = ["A.", "B.", "C.", "D.","E.", "F.","G.", "H.","I.", "J.","K.", "L.","M.", "N.","O.", "P.","Q.", "R.","S.", "T.","U.", "V.","W.", "X.","Y.", "Z."];
	prefix = ["Le", "Mc", "Mac", "O'", "", "", "", "", "", "", "", "", "", "", "", ""];
	core = ["Brookes", "Beynon", "Russ", "Jones", "Smith", "Beckham", "Eadie", "Goss", "Gunn", "Ashton", "Pakarani", "Huckerby", "Tissier", "Oddie", "Green", "Shearer", "Owen", "Neil", "Kenton", "Walcott", "Platt", "Ferdinand", "Hughes", "Drury", "Fleming", "Etuhu", "Ronaldo", "Norwich"];
	suffix = ["son","","","", "ovich", "", "", "", "", "", "", "", "", "", "", ""];
	
	addresses = ["AV", "Hurst", "JM", "Redfern", "Rootes", "Tocil", "Whitefields"];
	
	receivedDate = stringSystemStartDay // "-" // stringSystemStartMonth // "-" // stringSystemStartYear;
	
	for (i=1; i<=loadLedgerSize; i++)
	{
		fName = firstName[rnd(firstName# - 1)+1] // prefix[rnd(prefix#-1)+1] // core[rnd(core#-1)+1] // suffix[rnd(suffix#-1)+1];
		adds = addresses[rnd(addresses# - 1)+1] // " " // str(rnd(49)+1);
		addMailToLedger(fName,adds,receivedDate,"");			
	}
	
	##reset load ledger
	loadMailLedgerTextbox_setText("");
};

proc clockSpeedButton_trigger : clockSpeedButton_mouse_1
{
	if(clockSpeedButton_mouse_1[2] == 5)
	{
		actualTimeSpeed = int(clockSpeedTextbox_getText());
		writeln(int(clockSpeedTextbox_getText()));
		writeln(actualTimeSpeed);
		setedenclock(&timeclock, 10000/actualTimeSpeed);
	};
	
};

proc resetButton_trigger : resetButton_mouse_1
{
	resetSystem();	
};

##reset button clears the spreadsheet and resets all system data.
proc resetSystem
{
	if(resetButton_mouse_1[2]==5)
	{
		include("postRoomDependencies.e");
		
		resetLedgerElements();
		
		clockSpeedTextbox_setText(str(actualTimeSpeed));		
		
		##reset load ledger
		loadMailLedgerTextbox_setText("");
	};		
};

proc resetLedgerElements
{
	blankString = "";
	for(i=1; i<=numberOfSpreadsheetElements; i++)
	{
		execute("element1"//str(i)//"_setText(blankString);");
		execute("element2"//str(i)//"_setText(blankString);");
		execute("element3"//str(i)//"_setText(blankString);");
		execute("element4"//str(i)//"_setText(blankString);");
		
		offColour = "red";
		execute("button"//str(i)//"Colour = offColour;");
	}
};